#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define TIMEOUT 5

int main(int argc, char *argv[])
{
  fd_set rfds;
  struct timeval tv;
  int retval;
  char c = '\0';

  /* Watch stdin */
  FD_ZERO(&rfds);
  FD_SET(0, &rfds);

  printf("'q' to quit\n");
  fflush(stdout);

  /* set terminal to send every key stroke */
  system("stty raw -echo");

  while (1) {
    tv.tv_sec = TIMEOUT;
    tv.tv_usec = 0;
    retval = select(1, &rfds, NULL, NULL, &tv);

    if (retval == -1){
        perror("select()");
        exit(EXIT_FAILURE);
    } else if (retval){
        c = getchar();
        if (c == 'q')
          break;
        else {
          printf("key: %c\n\r", c);
          fflush(stdout);
        }
    } else {
        printf("No data within %d seconds.\n\r", TIMEOUT);
        break;
   }
  }

  system("stty cooked echo");

  exit(EXIT_SUCCESS);
}
